/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

namespace Signal::Store {

    class SessionStore {
    public:
        static void boundToContext(signal_protocol_store_context *ctx);

        int loadSession(signal_buffer **record, signal_buffer **user_record, const signal_protocol_address *address);
        int getSubDeviceSessions(signal_int_list **sessions, const char *name, size_t name_len);
        int storeSession(const signal_protocol_address *address, uint8_t *record, size_t record_len,
                         uint8_t *user_record, size_t user_record_len);
        int containsSession(const signal_protocol_address *address);
        int deleteSession(const signal_protocol_address *address);
        int deleteAllSessions(const char *name, size_t name_len);
    };

} // namespace Signal::Store
